package cn.com.qmth.examcloud.task.service.impl;

import java.util.List;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.commons.api.HandleSyncCloudService;
import cn.com.qmth.examcloud.commons.api.request.SyncCourseReq;
import cn.com.qmth.examcloud.commons.api.request.SyncExamReq;
import cn.com.qmth.examcloud.commons.api.request.SyncExamStudentReq;
import cn.com.qmth.examcloud.commons.api.request.SyncOrgReq;
import cn.com.qmth.examcloud.commons.api.request.SyncSpecialtyReq;
import cn.com.qmth.examcloud.commons.api.request.SyncStudentReq;
import cn.com.qmth.examcloud.commons.api.response.SyncCourseResp;
import cn.com.qmth.examcloud.commons.api.response.SyncExamResp;
import cn.com.qmth.examcloud.commons.api.response.SyncExamStudentResp;
import cn.com.qmth.examcloud.commons.api.response.SyncOrgResp;
import cn.com.qmth.examcloud.commons.api.response.SyncSpecialtyResp;
import cn.com.qmth.examcloud.commons.api.response.SyncStudentResp;
import cn.com.qmth.examcloud.commons.base.exception.StatusException;
import cn.com.qmth.examcloud.commons.base.util.JsonUtil;
import cn.com.qmth.examcloud.commons.base.util.PropertiesUtil;
import cn.com.qmth.examcloud.commons.base.util.RegExpUtil;
import cn.com.qmth.examcloud.task.dao.DataSyncRepo;
import cn.com.qmth.examcloud.task.dao.entity.DataSyncEntity;
import cn.com.qmth.examcloud.task.service.DataSyncService;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年9月19日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Service
public class DataSyncServiceImpl implements DataSyncService {

	@Autowired
	DataSyncRepo dataSyncRepo;

	@Autowired
	HandleSyncCloudService handleSyncCloudService;

	@Override
	public SyncCourseResp syncCourse(SyncCourseReq req) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public SyncOrgResp syncOrg(SyncOrgReq req) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public SyncStudentResp syncStudent(SyncStudentReq req) {
		String group = PropertiesUtil.getString("$sync.syncStudent.group");
		if (StringUtils.isBlank(group)) {
			throw new StatusException("T-001001", "group is not configured");
		}

		List<String> componentList = RegExpUtil.findAll(group, "[^\\,]+");

		if (CollectionUtils.isEmpty(componentList)) {
			throw new StatusException("T-001001", "no component");
		}

		for (String component : componentList) {
			String url = PropertiesUtil.getString("$sync.syncStudent.component." + component);
			req.setUrl(url);
			try {
				handleSyncCloudService.syncStudent(req);
			} catch (Exception e) {
				DataSyncEntity entity = new DataSyncEntity();
				entity.setMethodName("syncStudent");
				entity.setParamType(
						cn.com.qmth.examcloud.commons.api.request.SyncStudentReq.class.getName());
				entity.setSyncNum(0);
				entity.setParamJson(JsonUtil.toJson(req));
				dataSyncRepo.saveAndFlush(entity);
			}
		}

		SyncStudentResp resp = new SyncStudentResp();
		return resp;
	}

	@Override
	public SyncExamStudentResp syncExamStudent(SyncExamStudentReq req) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public SyncSpecialtyResp syncSpecialty(SyncSpecialtyReq req) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public SyncExamResp syncExam(SyncExamReq req) {
		// TODO Auto-generated method stub
		return null;
	}

}
